/*
 * Copyright 2006 Robert Hanson <iamroberthanson AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.gwtwidgets.client.ui.pagination;

/**
 * RowRenderer lets you dynamically set the widgets for the cells of the table.
 * populateRow is called once for every object on the Pagination page.
 * 
 * @author Joe Toth (joetoth@gmail.com)
 * 
 */
public interface RowRenderer {
	/**
	 * @param pagination
	 * @param row
	 *            The row the object should be populated on. NOTE: row starts
	 *            from 1 since 0 is the header row.
	 * @param object
	 */
	public void populateRow(PaginationBehavior pagination, int row, Object object);
}
